---
title: Buttons
slug: Games/Tutorials/2D_breakout_game_Phaser/Buttons
tags:
  - 2D
  - Beginner
  - Buttons
  - Canvas
  - Games
  - JavaScript
  - Phaser
  - Tutorial
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Animations_and_tweens", "Games/Workflows/2D_Breakout_game_Phaser/Randomizing_gameplay")}}</p>

<div class="summary">
<p>This is the <strong>15th step</strong> out of 16 of the <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser">Gamedev Phaser tutorial</a>. You can find the source code as it should look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/lesson15.html">Gamedev-Phaser-Content-Kit/demos/lesson15.html</a>.</p>
</div>

<p><span class="seoSummary">Instead of starting the game right away we can leave that decision to the player by adding a Start button they can press. Let's investigate how to do that.</span></p>

<h2 id="New_variables">New variables</h2>

<p>We will need a variable to store a boolean value representing whether the game is currently being played or not, and another one to represent our button. Add these lines below your other variable definitions:</p>

<pre class="brush: js notranslate">var playing = false;
var startButton;
</pre>

<h2 id="Loading_the_button_spritesheet">Loading the button spritesheet</h2>

<p>We can load the button spritesheet the same way we loaded the ball's wobble animation. Add the following to the bottom of the <code>preload()</code> function:</p>

<pre class="brush: js notranslate">game.load.spritesheet('button', 'img/button.png', 120, 40);
</pre>

<p>A single button frame is 120 pixels wide and 40 pixels high.</p>

<p>You also need to <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/img/button.png">grab the button spritesheet from Github</a>, and save it in your <code>/img</code> directory.</p>

<h2 id="Adding_the_button_to_the_game">Adding the button to the game</h2>

<p>Adding the new button to the game is done by using the <code>add.button</code> method. Add the following lines to the bottom of your <code>create()</code> function:</p>

<pre class="brush: js notranslate">startButton = game.add.button(game.world.width*0.5, game.world.height*0.5, 'button', startGame, this, 1, 0, 2);
startButton.anchor.set(0.5);
</pre>

<p>The <code>button()</code> method's parameters are as follows:</p>

<ul>
 <li>The button's x and y coordinates</li>
 <li>The name of the graphic asset to be displayed for the button</li>
 <li>A callback function that will be executed when the button is pressed</li>
 <li>A reference to <code>this</code> to specify the execution context</li>
 <li>The frames that will be used for the <em>over</em>, <em>out</em> and <em>down</em> events.</li>
</ul>

<div class="note">
<p><strong>Note</strong>: The over event is the same as hover, out is when the pointer moves out of the button and down is when the button is pressed.</p>
</div>

<p>Now we need to define the <code>startGame()</code> function referenced in the code above:</p>

<pre class="brush: js notranslate">function startGame() {
    startButton.destroy();
    ball.body.velocity.set(150, -150);
    playing = true;
}
</pre>

<p>When the button is pressed, we remove the button, sets the ball's initial velocity and set the <code>playing</code> variable to <code>true</code>.</p>

<p>Finally for this section, go back into your <code>create()</code> function, find the <code>ball.body.velocity.set(150, -150);</code> line, and remove it. You only want the ball to move when the button is pressed, not before!</p>

<h2 id="Keeping_the_paddle_still_before_the_game_starts">Keeping the paddle still before the game starts</h2>

<p>It works as expected, but we can still move the paddle when the game hasn't started yet, which looks a bit silly. To stop this, we can take advantage of the <code>playing</code> variable and make the paddle movable only when the game has started. To do that, adjust the <code>update()</code> function like so:</p>

<pre class="brush: js notranslate">function update() {
    game.physics.arcade.collide(ball, paddle, ballHitPaddle);
    game.physics.arcade.collide(ball, bricks, ballHitBrick);
    if(playing) {
        paddle.x = game.input.x || game.world.width*0.5;
    }
}
</pre>

<p>That way the paddle is immovable after everything is loaded and prepared, but before the start of the actual game.</p>

<h2 id="Compare_your_code">Compare your code</h2>

<p>You can check the finished code for this lesson in the live demo below, and play with it to understand better how it works:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/1rpj71k4/","","400")}}</p>

<h2 id="Next_steps">Next steps</h2>

<p>The last thing we will do in this article series is make the gameplay even more interesting by adding some <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser/Randomizing_gameplay">randomization</a> to the way the ball bounces off the paddle.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Animations_and_tweens", "Games/Workflows/2D_Breakout_game_Phaser/Randomizing_gameplay")}}</p>
